struct pixel {
	unsigned char r;
	unsigned char g;
	unsigned char b;
	unsigned char a;
};

struct imagestruct {
	pixel** data;
	unsigned short width,height;
};

bool image_load_empty(imagestruct* image, unsigned short width, unsigned short height, unsigned char r, unsigned char g, unsigned char b, unsigned char a);
bool image_load_bmp(imagestruct* image, const char* filename);
bool image_save_bmp(imagestruct* image, const char* filename, bool savealpha);
void image_free(imagestruct* image);

