#define export extern "C" __declspec (dllexport) __stdcall

#include "bmp.h"

#define max(a,b) ((a>b)?(a):(b))
#define min(a,b) ((a<b)?(a):(b))

struct gmrender_texture {
	unsigned long id;
	imagestruct image;
	gmrender_texture *next;
};

struct gmrender_triangle {
	signed short x1,y1,z1;
	signed short x2,y2,z2;
	signed short x3,y3,z3;
	signed char nx1,ny1,nz1;
	signed char nx2,ny2,nz2;
	signed char nx3,ny3,nz3;
	signed short tx1,ty1;
	signed short tx2,ty2;
	signed short tx3,ty3;
	pixel col1;
	pixel col2;
	pixel col3;
};

struct gmrender_model {
	unsigned long id;
	gmrender_triangle* triangles;
	unsigned short trianglecount;
	gmrender_texture* texture;
	bool tex_repeat,tex_interpolate;
	unsigned char highlight_r,highlight_g,highlight_b;
	unsigned short specular_exponent;
	gmrender_model *next;
};

struct gmrender_triangle2 {
	float x1,y1,z1;
	float x2,y2,z2;
	float x3,y3,z3;
	float nx1,ny1,nz1;
	float nx2,ny2,nz2;
	float nx3,ny3,nz3;
	float tx1,ty1;
	float tx2,ty2;
	float tx3,ty3;
	float r1,g1,b1,a1;
	float r2,g2,b2,a2;
	float r3,g3,b3,a3;
	float add_r1,add_g1,add_b1;
	float add_r2,add_g2,add_b2;
	float add_r3,add_g3,add_b3;
	float specular_exponent;
	gmrender_texture* texture;
	bool tex_repeat,tex_interpolate;
};

